(function($){
	$(document).ready(function(){
		var _init = function()
		{
			if (!$('.jreview-quick-star').not('.loaded').length) return;

			var data = [],
				_els = $('.jreview-quick-star').not('.loaded');
			
			_els.each(function(){
				var _el = $(this);
				data.push({
					comp: _el.attr('data-object'),
					id: _el.attr('data-id')
				});
			});

			$.post(baseUrl, {cid:JSON.stringify(data)}, function(d){
				var max = d.params.max*1;

				if (d.params.type==0)
				{
					$('.jreview-quick-star').addClass('loaded');
					return;
				}

				if (d.data!=null)
				{
					$.each(d.data, function(k,v){
						var classSuf = v.object + '_' + v.object_id,
							_el = $('.' + classSuf);

						_el.addClass('loaded');

						if (d.params.type==1 || d.params.type==3)
						{
							var html = '<div class="starContainer"><div class="reviewStars">';

							for (var i=0;i<max;i++)
							{
								var _rating = v.rating*1,
									_lgFill = _rating<i?0:(_rating-1>=i?100:parseInt((_rating-i)*100));
								html+= '<span class="_starBox _star'+(i+1)+'">';
									html+= '<span class="_active" style="width:'+_lgFill+'%"></span>';
									html+= '<span class="_star"></span>';
								html+= '</span>';
							}

							html+= '</div>';

							if (typeof _el.attr("data-count")=='undefined' || _el.attr("data-count")==1)
							{
								if (v.count_rating*1>0)
								{
									html+= '<a href="'+v.url+'#reviews" class="jreview-begin">';
									html+= v.count_rating+' '+(v.count_rating>1?d.langs.ratings:d.langs.rating)+'</a>';
								} else {
									html+= '<a href="'+v.url+'#add-review" class="jreview-begin">';
									html+= d.langs.no_rating_desc+'</a>';
								}
							}

							html+= '</div>';

							_el.empty().append(html);
						}

						// criterias
						if (v.criteria!=null && (d.params.type==2 || d.params.type==3))
						{
							_el.append('<div class="_criterias"></div>');
							$.each(v.criteria, function(k1,v1){
								var _percent = parseInt(v1.rating*100/v1.max),
									_label = _percent+'%',
									_cp = $('<div class="_factors"></div>');

								_cp.append('<div class="_pci"></div>');
								_cp.append('<span class="_label">'+v1.label+'</span>');
								_cp.find('._pci').append('<span>'+_label+'</span><div class="slice"><div class="bar"></div><div class="fill"></div></div>');
								

								if (_percent>50)
								{
									_cp.find('._pci').addClass('gt50');
								}

								var _deg = parseInt(_percent*360/100);

								_cp.find('.bar').css({
									'-webkit-transform':'rotate('+_deg+'deg)',
								    '-moz-transform': 'rotate('+_deg+'deg)',
								    '-o-transform': 'rotate('+_deg+'deg)',
								    '-ms-transform': 'rotate('+_deg+'deg)',
								    'transform': 'rotate('+_deg+'deg)'
								});

								if (typeof d.params.rtext == "object")
								{
									$.each(d.params.rtext, function(k2,v2){
										if(_percent<=parseFloat(v2.max) && _percent>=parseFloat(v2.min))
										{
											_cp.find('.bar,.fill').css('borderColor', '#'+v2.color);
										}
									});
								}

								_cp.appendTo( _el.find('._criterias') );
							});
						}
					});
				}
				

				if (d.params.type==1 || d.params.type==3)
				{
					$('.jreview-quick-star').not('.loaded').each(function(){
						var _el = $(this),
							html = '<div class="starContainer"><div class="reviewStars">';

						_el.addClass('loaded');

						for (var i=0;i<max;i++)
						{
							html+= '<span class="_starBox _star'+(i+1)+'">';
								html+= '<span class="_active"></span>';
								html+= '<span class="_star"></span>';
							html+= '</span>';
						}

						html+= '</div>';

						if (typeof _el.attr('data-url')!= 'undefined' && (typeof _el.attr("data-count")=='undefined' || _el.attr("data-count")==1))
						{
							html+= '<a href="'+_el.attr('data-url')+'#add-review" class="jreview-begin">'+d.langs.no_rating_desc+'</a>';
						}

						html+= '</div>';

						_el.empty().append(html);
					});
				}
			}, 'json');
		};

		_init();
		window.setInterval(function(){
			_init();
		},1000);
	});
})(jQuery);